From ad7186a89fa4f6057167a650e0e284f5d5703164 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 24 2020 22:37:49 +0000
Subject: [PATCH 348/2232] Produce better error on const_assert failures


The new message includes the value of the left and right side. The
previous message did not include the values, just said it failed.

---

diff --git a/src/assert.rs b/src/assert.rs
index 6159ce6..cc736dc 100644
--- a/src/assert.rs
+++ b/src/assert.rs
@@ -1,30 +1,5 @@
-pub struct True;
-pub struct False;
-
-pub trait ToBool {
-    type Bool: Sized;
-    const BOOL: Self::Bool;
-}
-
-impl ToBool for [(); 0] {
-    type Bool = False;
-    const BOOL: Self::Bool = False;
-}
-
-impl ToBool for [(); 1] {
-    type Bool = True;
-    const BOOL: Self::Bool = True;
-}
-
-macro_rules! bool {
-    ($e:expr) => {{
-        const EXPR: bool = $e;
-        <[(); EXPR as usize] as $crate::assert::ToBool>::BOOL
-    }};
-}
-
-macro_rules! const_assert {
-    ($e:expr) => {
-        const _: $crate::assert::True = bool!($e);
+macro_rules! const_assert_eq {
+    ($left:expr, $right:expr) => {
+        const _: [(); $left] = [(); $right];
     };
 }
diff --git a/src/rust_sliceu8.rs b/src/rust_sliceu8.rs
index a0c348b..6e987a8 100644
--- a/src/rust_sliceu8.rs
+++ b/src/rust_sliceu8.rs
@@ -23,4 +23,4 @@ impl RustSliceU8 {
     }
 }
 
-const_assert!(mem::size_of::<Option<RustSliceU8>>() == mem::size_of::<RustSliceU8>());
+const_assert_eq!(mem::size_of::<Option<RustSliceU8>>(), mem::size_of::<RustSliceU8>());
diff --git a/src/rust_str.rs b/src/rust_str.rs
index 51e4835..184e2c1 100644
--- a/src/rust_str.rs
+++ b/src/rust_str.rs
@@ -31,4 +31,4 @@ unsafe extern "C" fn str_valid(ptr: *const u8, len: usize) -> bool {
     str::from_utf8(slice).is_ok()
 }
 
-const_assert!(mem::size_of::<Option<RustStr>>() == mem::size_of::<RustStr>());
+const_assert_eq!(mem::size_of::<Option<RustStr>>(), mem::size_of::<RustStr>());

